require 'rake'
include Rake::DSL
include Logging

class Task
	def initialize(name, *args, &body)
		args || args = []
		args.insert 0, name

		# allows you to define your own overriden tasks
		# hardcoded tasks are added first, then user dynamic ones, then finally rakeoff dynamic ones
		if(Rake::Task.task_defined?(name))
			logger.info 'Unable to overwrite task #{name} as it already exists'.yellow 		    
			return
		end
		
		Rake::Task.define_task(*args, &body)
	end	
end
